Attribute VB_Name = "mMenuXP"
Option Explicit

'/*
' New window procedure
'   
Public Function wlNewProc(ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim PAPI As POINTAPI
Dim hMenu As Long, lMenuCount As Long, i As Long, lMenuId As Long
Dim MSIS As MEASUREITEMSTRUCT, DIS As DRAWITEMSTRUCT
Dim strMenuItemString As String, strTMP As String
Dim CheckRC As RECT
Dim PictureRC As RECT
Dim TextRC As RECT
Dim hBr As Long
Dim lBitmap As Long

strMenuItemString = String$(100, Chr(32))

    Select Case wMsg
        Case WM_DESTROY, WM_CLOSE
            Call SetWindowLong(ByVal hwnd, ByVal GWL_WNDPROC, wlOldProc)

        Case WM_NCMOUSEMOVE
            If wParam = HTMENU Then     'hit-test value
                hMenu = GetMenu(ByVal hwnd&)
                lMenuCount = GetMenuItemCount(ByVal hMenu&)
                PAPI = MakePoint(ByVal lParam)
                lMenuId = MenuItemFromPoint(ByVal hwnd&, ByVal hMenu&, ByVal PAPI.x, ByVal PAPI.y)
                If lMenuId <> -1 Then
                    For i = 0 To lMenuCount - 1
                        If i = lMenuId Then
                            ' HILITE menu item selected
                            '     
                            Call HiliteMenuItem(ByVal hwnd, ByVal hMenu&, ByVal i&, MF_BYPOSITION Or MF_HILITE)
                        Else
                            ' Remove the HILITE
                            '    
                            Call HiliteMenuItem(ByVal hwnd, ByVal hMenu&, ByVal i&, MF_BYPOSITION Or MF_UNHILITE)
                        End If
                    Next i
                Else
                    ' Remove the HILITE
                    '    
                    For i = 0 To lMenuCount - 1
                        Call HiliteMenuItem(ByVal hwnd, ByVal hMenu&, ByVal i&, MF_BYPOSITION Or MF_UNHILITE)
                    Next i
                End If
            Else
                hMenu = GetMenu(ByVal hwnd&)
                lMenuCount = GetMenuItemCount(ByVal hMenu&)
                For i = 0 To lMenuCount - 1
                    Call HiliteMenuItem(ByVal hwnd, ByVal hMenu&, ByVal i&, MF_BYPOSITION Or MF_UNHILITE)
                Next i
            End If
        
        Case WM_MOUSEMOVE
            ' Remove the HILITE
            '       
            hMenu = GetMenu(ByVal hwnd&)
            lMenuCount = GetMenuItemCount(ByVal hMenu&)
            For i = 0 To lMenuCount - 1
                Call HiliteMenuItem(ByVal hwnd, ByVal hMenu&, ByVal i&, MF_BYPOSITION Or MF_UNHILITE)
            Next i
        
        Case WM_MEASUREITEM            ' setting the size for menu item (   )
            hMenu = GetMenu(ByVal hwnd&)
            Call CopyMemory(MSIS, ByVal lParam, ByVal LenB(MSIS))
            If IsMenuItemInTopRow(ByVal hwnd&, ByVal MSIS.ItemID) Then    ' if Menu Item in top row(   )
                ' get menu string (  )
                Call GetMenuString(ByVal hMenu, MSIS.ItemID, strMenuItemString$, ByVal Len(strMenuItemString), ByVal MF_BYCOMMAND)
                strMenuItemString$ = RTrim$(Replace(strMenuItemString$, vbNullChar, ""))
                MSIS.itemWidth = frmMenuXP.TextWidth(strMenuItemString$) + 6
            Else                                                    ' others menu items(  )
                ' get menu string (  )
                Call GetMenuString(ByVal hMenu, MSIS.ItemID, strMenuItemString$, ByVal Len(strMenuItemString), ByVal MF_BYCOMMAND)
                strMenuItemString$ = RTrim$(Replace(strMenuItemString$, vbNullChar, ""))
                If IsShortcut(ByVal strMenuItemString$) Then MSIS.itemWidth = 20
                If IsHavingSabMenu(ByVal hwnd&, ByVal MSIS.ItemID&) Then MSIS.itemWidth = 40
                MSIS.itemWidth = MSIS.itemWidth + frmMenuXP.TextWidth(strMenuItemString$) + 45
                If IsSeparator(ByVal hwnd&, ByVal MSIS.ItemID&) Then
                    MSIS.itemHeight = 5
                Else
                    MSIS.itemHeight = 22
                End If
            End If
            Call CopyMemory(ByVal lParam, MSIS, ByVal LenB(MSIS))
        
        Case WM_DRAWITEM
            If wParam = 0 Then        ' draw menu item (  )
                Call CopyMemory(DIS, ByVal lParam, LenB(DIS))
                ' set TRANSPARENT style( )
                Call SetBkMode(DIS.hdc, TRANSPARENT)
                ' get menu item string(  )
                Call GetMenuString(GetMenu(hwnd), DIS.ItemID, strMenuItemString$, Len(strMenuItemString$), MF_BYCOMMAND)
                strMenuItemString$ = Trim$(Replace(strMenuItemString$, vbNullChar, ""))
                ' check bitmap(   Bitmap)
                lBitmap = IsHavingBitmap(ByVal strMenuItemString$)
                If lBitmap <> 0 Then
                    strMenuItemString$ = CutBitmapIndex(ByVal strMenuItemString$)
                End If
                '/*
                If (DIS.itemState And ODS_SELECTED) Then ' Menu Item is selected (  )
                    If IsMenuItemInTopRow(ByVal hwnd&, ByVal DIS.ItemID) Then    ' if Menu Item in top row(   )
                        Call FillRectangle(DIS.hdc, DIS.rcItem, COL_MENU_HILITE)
                        Call SetTextColor(ByVal DIS.hdc&, ByVal COL_MENUTEXT_HILITE&)
                        hBr = CreateSolidBrush(ByVal COL_MENUBORDER&)
                        Call FrameRect(DIS.hdc, DIS.rcItem, hBr)
                        Call DeleteObject(hBr)
                        Call DrawText(DIS.hdc, strMenuItemString$, Len(strMenuItemString$), DIS.rcItem, DT_CENTER Or DT_SINGLELINE Or DT_VCENTER)
                    Else
                        ' fill rect menu item(    )
                        If Not IsDisabled(ByVal hwnd&, ByVal DIS.ItemID) Then
                            Call FillRectangle(DIS.hdc, DIS.rcItem, COL_SUBMENU_HILITE)
                            ' draw boder( )
                            hBr = CreateSolidBrush(ByVal COL_MENUBORDER&)
                            Call FrameRect(DIS.hdc, DIS.rcItem, hBr)
                            Call DeleteObject(hBr)
                        End If
                        ' draw the bitmap( )
                        If lBitmap <> 0 Then
                            CheckRC.Top = DIS.rcItem.Top + 1: CheckRC.Left = DIS.rcItem.Left + 2
                            CheckRC.Right = CheckRC.Left + 20: CheckRC.Bottom = CheckRC.Top + 20
                            Call DrawBitmap(ByVal DIS.hdc, ByVal 1&, ByVal 1&, ByVal lBitmap&, CheckRC, ByVal DP_SHADOW)
                            Call DrawBitmap(ByVal DIS.hdc, ByVal -1&, ByVal -1&, ByVal lBitmap&, CheckRC, ByVal DP_COLOR)
                        End If
                        ' draw the check( )
                        If IsChecked(ByVal hwnd&, ByVal DIS.ItemID) Then
                            CheckRC.Top = DIS.rcItem.Top + 1: CheckRC.Left = DIS.rcItem.Left + 2
                            CheckRC.Right = CheckRC.Left + 20: CheckRC.Bottom = CheckRC.Top + 20
                            Call DrawBitmap(ByVal DIS.hdc, ByVal 0&, ByVal 0&, ByVal 101&, CheckRC, ByVal DP_COLOR)
                        End If
                        ' set font color(  )
                        If Not IsDisabled(ByVal hwnd&, ByVal DIS.ItemID) Then
                            Call SetTextColor(ByVal DIS.hdc&, ByVal COL_SUBMENUTEXT_HILITE&)
                        Else
                            Call SetTextColor(ByVal DIS.hdc&, ByVal COL_SUBMENUTEXT_GRAYED&)
                        End If
                        ' write the text( )
                        TextRC.Top = DIS.rcItem.Top: TextRC.Left = DIS.rcItem.Left + 35
                        TextRC.Right = DIS.rcItem.Right - 5: TextRC.Bottom = DIS.rcItem.Bottom
                        If IsShortcut(ByVal strMenuItemString$) Then
                            i = InStr(1, strMenuItemString$, Chr(9))
                            strTMP$ = Mid$(strMenuItemString$, 1, i - 1)
                            Call DrawText(DIS.hdc, strTMP$, Len(strTMP$), TextRC, DT_LEFT Or DT_SINGLELINE Or DT_VCENTER)
                            strTMP$ = Mid$(strMenuItemString$, i + 1, Len(strMenuItemString$) - i)
                            Call DrawText(DIS.hdc, strTMP$, Len(strTMP$), TextRC, DT_RIGHT Or DT_SINGLELINE Or DT_VCENTER)
                        Else
                            Call DrawText(DIS.hdc, strMenuItemString$, Len(strMenuItemString$), TextRC, DT_LEFT Or DT_SINGLELINE Or DT_VCENTER)
                        End If
                    End If
                Else                                     ' Menu Item is NOT selected (   )
                    If IsMenuItemInTopRow(ByVal hwnd&, ByVal DIS.ItemID) Then    ' if Menu Item in top row(   )
                        Call FillRectangle(DIS.hdc, DIS.rcItem, COL_MENU)
                        Call SetTextColor(ByVal DIS.hdc&, ByVal COL_MENUTEXT&)
                        Call DrawText(DIS.hdc, strMenuItemString$, Len(strMenuItemString$), DIS.rcItem, DT_CENTER Or DT_SINGLELINE Or DT_VCENTER)
                    Else
                        ' fill rect menu item(    )
                        Call FillRectangle(DIS.hdc, DIS.rcItem, COL_SUBMENU)
                        ' fill rect bitmap/check(  /)
                        PictureRC.Top = DIS.rcItem.Top: PictureRC.Left = DIS.rcItem.Left
                        PictureRC.Right = PictureRC.Left + 25: PictureRC.Bottom = PictureRC.Top + 22
                        Call FillRectangle(DIS.hdc, PictureRC, COL_BITMAP_BACKGROUND)
                        ' draw the bitmap( )
                        If lBitmap <> 0 Then
                            CheckRC.Top = DIS.rcItem.Top + 1: CheckRC.Left = DIS.rcItem.Left + 2
                            CheckRC.Right = CheckRC.Left + 20: CheckRC.Bottom = CheckRC.Top + 20
                            Call DrawBitmap(ByVal DIS.hdc, ByVal 0&, ByVal 0&, ByVal lBitmap&, CheckRC, ByVal DP_COLOR)
                        End If
                        ' draw the check( )
                        If IsChecked(ByVal hwnd&, ByVal DIS.ItemID) Then
                            CheckRC.Top = DIS.rcItem.Top + 1: CheckRC.Left = DIS.rcItem.Left + 2
                            CheckRC.Right = CheckRC.Left + 20: CheckRC.Bottom = CheckRC.Top + 20
                            Call DrawBitmap(ByVal DIS.hdc, ByVal 0&, ByVal 0&, ByVal 101&, CheckRC, ByVal DP_COLOR)
                        End If
                        ' set font color(  )
                        If Not IsDisabled(ByVal hwnd&, ByVal DIS.ItemID) Then
                            Call SetTextColor(ByVal DIS.hdc&, ByVal COL_SUBMENUTEXT&)
                        Else
                            Call SetTextColor(ByVal DIS.hdc&, ByVal COL_SUBMENUTEXT_GRAYED&)
                        End If
                        ' write the text( )
                        TextRC.Top = DIS.rcItem.Top: TextRC.Left = DIS.rcItem.Left + 35
                        TextRC.Right = DIS.rcItem.Right - 5: TextRC.Bottom = DIS.rcItem.Bottom
                        If IsShortcut(ByVal strMenuItemString$) Then
                            i = InStr(1, strMenuItemString$, Chr(9))
                            strTMP$ = Mid$(strMenuItemString$, 1, i - 1)
                            Call DrawText(DIS.hdc, strTMP$, Len(strTMP$), TextRC, DT_LEFT Or DT_SINGLELINE Or DT_VCENTER)
                            strTMP$ = Mid$(strMenuItemString$, i + 1, Len(strMenuItemString$) - i)
                            Call DrawText(DIS.hdc, strTMP$, Len(strTMP$), TextRC, DT_RIGHT Or DT_SINGLELINE Or DT_VCENTER)
                        Else
                            Call DrawText(DIS.hdc, strMenuItemString$, Len(strMenuItemString$), TextRC, DT_LEFT Or DT_SINGLELINE Or DT_VCENTER)
                        End If
                    End If
                End If
                ' if separator( )
                If IsSeparator(ByVal hwnd&, ByVal DIS.ItemID) Then
                    DIS.rcItem.Top = DIS.rcItem.Top + 2: DIS.rcItem.Bottom = DIS.rcItem.Bottom - 2
                    DIS.rcItem.Left = DIS.rcItem.Left + 35
                    Call FillRectangle(DIS.hdc, DIS.rcItem, COL_SEPARATOR)
                End If
            End If
    End Select
    wlNewProc = CallWindowProc(wlOldProc, ByVal hwnd, ByVal wMsg, ByVal wParam, ByVal lParam)

End Function

